package com.xefer.rebel;

import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;

class MethodNotAllowedException extends ResourceException {

  String allowedMethods;

  public MethodNotAllowedException(String message, String allowedMethods) {
     super(HttpServletResponse.SC_METHOD_NOT_ALLOWED, message);
     
     this.allowedMethods = allowedMethods;
  }

  public void report(HttpServletResponse response) throws IOException {

    response.setHeader("Allow", allowedMethods);

    super.report(response);
    
  }

}
