package com.xefer.rebel;

import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;

class ResourceException extends ServletException {

  int statusCode;
  Throwable rootCause;
  
  public ResourceException(int statusCode, String message) {
    super(message);

    this.rootCause  = null;
    this.statusCode = statusCode;

  }

  public ResourceException(int statusCode, Throwable rootCause) {
    super(rootCause);

    this.rootCause  = rootCause;
    this.statusCode = statusCode;
    
  }
  
  public ResourceException(int statusCode, String message, Throwable rootCause) {
    super(message, rootCause);

    this.rootCause  = rootCause;
    this.statusCode = statusCode;
    
  }

  public ResourceException(Throwable rootCause) {
    super(rootCause);

    this.rootCause  = rootCause;
    this.statusCode = statusCode;
    
  }
  
  public int getStatusCode() {
    return statusCode;
  }

  public String getMessage() {
    return "<?xml version=\"1.0\"?>\n<error>" + super.getMessage() + "</error>";
  }


  public void report(HttpServletResponse response) throws IOException {

    response.setStatus(statusCode);
    response.setContentType("text/xml");
    response.getOutputStream().print(getMessage());
  
    if(rootCause != null) {
      rootCause.printStackTrace();
    }

  }

  static public String getMessage(Throwable cause) {
  
    cause.printStackTrace();
    
    return "Internal Server Error: " + cause.getMessage();    
    
  }
  
}